=== data/CMakeLists.txt ===
add_subdirectory(examples)

INSTALL(
    FILES
        License.txt
    DESTINATION
        ${CMAKE_INSTALL_DATADIR}
)
