=== debian/changelog ===
freecad (0.16.6712+dfsg1-1ubuntu2) bionic; urgency=medium

  * Fix autopkgtest on architectures where char is unsigned by default,
    thanks Frédéric Bonnard (Closes: #836983)
  * Build everywhere

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 07 Dec 2017 19:01:39 +0000

freecad (0.16.6712+dfsg1-1ubuntu1) bionic; urgency=medium

  * Don't build the package on ppc64el and s390x, test failures.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 20 Nov 2017 11:57:53 +0100

freecad (0.16.6712+dfsg1-1build1) bionic; urgency=medium

  * No-change rebuild for libxerces soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 16 Nov 2017 11:58:56 +0000

freecad (0.16.6712+dfsg1-1) unstable; urgency=medium

  * [c631550] New upstream version 0.16.6712+dfsg1
  * [70d3ebc] Refresh patches
  * [c2f67a5] Remove dependency on Qt4 Webkit. (Closes: #784464)
  * [31d5630] Set Standards-Version: 4.1.0
  * [85cc9d9] Change priority to optional
  * [dc32b52] Set maximal hardening option
  * [c56abf6] Drop "alpha" from description. (Closes: #868727)

 -- Anton Gladky <gladk@debian.org>  Fri, 08 Sep 2017 22:55:20 +0200
