=== debian/control ===
Source: freecad
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Teemu Ikonen <tpikonen@gmail.com>,
           "Adam C. Powell, IV" <hazelsct@debian.org>,
           Anton Gladky <gladk@debian.org>
Section: science
Testsuite: autopkgtest
Priority: optional
Build-Depends: cmake,
               debhelper (>= 10),
               gfortran,
               libboost-date-time-dev,
               libboost-dev,
               libboost-filesystem-dev,
               libboost-graph-dev,
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libboost-python-dev,
               libboost-regex-dev,
               libboost-serialization-dev,
               libboost-signals-dev,
               libboost-thread-dev,
               libcoin80-dev,
               libopencv-dev | libcv-dev,
               libeigen3-dev (>= 3.3~beta1),
               libf2c2-dev,
               libfltk1.3-dev,
               libgts-bin,
               libgts-dev,
               liboce-foundation-dev (>= 0.17.1),
               liboce-modeling-dev (>= 0.17.1),
               liboce-ocaf-dev (>= 0.17.1),
               liboce-visualization-dev (>= 0.17.1),
               libode-dev,
               libpyside-dev,
               libqt4-dev,
               libshiboken-dev,
               libsoqt4-dev (>= 1.6),
               libspnav-dev,
               libtool,
               libx11-dev,
               libxerces-c-dev,
               libxext-dev,
               libxi-dev,
               libxmu-dev,
               libxt-dev,
               libzipios++-dev,
               oce-draw,
               python-pyside,
               pyside-tools,
               python-cxx-dev,
               python-dev,
               swig,
               zlib1g-dev
Standards-Version: 4.1.0
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/freecad.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/freecad.git
Homepage: http://freecadweb.org/

Package: freecad
Architecture: any
Depends: libsoqt4-20 (>= 1.6),
         python-collada,
         python-matplotlib,
         python-pivy (>= 0.5.0~v609hg-2) [!powerpc],
         python-ply,
         python-pyside,
         pyside-tools,
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Suggests: graphviz,
          povray
Description: Extensible Open Source CAx program
 FreeCAD is an Open Source CAx RAD based on OpenCasCade, Qt and Python.
 It features some key concepts like macro recording, workbenches, ability
 to run as a server and dynamically loadable application extensions and
 it is designed to be platform independent.
 .
 Currently, FreeCAD can import and display CAD models in IGES, STEP, and
 BRep formats and meshes in STL, BMS, AST and Wavefront OBJ formats.
 Editing and modeling features are currently somewhat limited.
