=== debian/tests/control ===
Tests: freecadtest
Depends: freecad
